/*
 * AbstractRecognizeVCRNeedsBehavior.java
 * Copyright (c) 2002 Boxed-Economy Project.  All rights reserved.
 */
package org.boxed_economy.formatcompetition.model.behavior;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

/**
* AbstractRecognizeVCRNeedsBehavior
*/
public abstract class AbstractRecognizeVCRNeedsBehavior
	extends AbstractBehavior {

	/**
	* This method automatically generated from AbstractBehavior Builder
	* Don't touch by hand
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState ~Fԑ҂ = factory.createCompositeState("~Fԑ҂");
		CompositeState ~ʑ҂ = factory.createCompositeState("~ʑ҂");
		CompositeState ~ʎM = factory.createCompositeState("~ʎM");
		State terminalState = factory.createTerminalState();

		//actions
		Action ~ʂ󂯎 = new Action() {
			public void doAction() {
				~ʂ󂯎();
			}
			public String toString() {
				return "~ʂ󂯎";
			}
		};
		Action ~˗ = new Action() {
			public void doAction() {
				~˗();
			}
			public String toString() {
				return "~˗";
			}
		};
		Action purchaseBehaviorN = new Action() {
			public void doAction() {
				purchaseBehaviorN();
			}
			public String toString() {
				return "purchaseBehaviorN";
			}
		};

		//guard-conditions
		GuardCondition ~ꂽꍇ = new GuardCondition() {
			public boolean isMatched(Event e) {
				return ~ꂽꍇ(e);
			}
		};
		GuardCondition ~ = new GuardCondition() {
			public boolean isMatched(Event e) {
				return ~(e);
			}
		};
		GuardCondition vCRĂȂꍇ = new GuardCondition() {
			public boolean isMatched(Event e) {
				return vCRĂȂꍇ(e);
			}
		};
		GuardCondition ~Ȃꍇ = new GuardCondition() {
			public boolean isMatched(Event e) {
				return ~Ȃꍇ(e);
			}
		};

		//transitions
		Transition transition~ʎMTo~Fԑ҂ = factory.createTransition();
		Transition transition~Fԑ҂To~ʑ҂ = factory.createTransition();
		Transition transition~ʑ҂To~ʎM = factory.createTransition();
		Transition transition~ʎMToTerminalState =
			factory.createTransition();
		Transition transitionInitialStateTo~Fԑ҂ =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(~Fԑ҂);
		this.addState(~ʑ҂);
		this.addState(~ʎM);
		this.addTerminalState(terminalState);

		//transitions setting
		transition~ʎMTo~Fԑ҂.setGuardCondition(~Ȃꍇ);
		transition~Fԑ҂To~ʑ҂.setEvent(TimeEvent.class);
		transition~Fԑ҂To~ʑ҂.setGuardCondition(vCRĂȂꍇ);
		transition~Fԑ҂To~ʑ҂.addAction(~˗);
		transition~ʑ҂To~ʎM.setEvent(ChannelEvent.class);
		transition~ʑ҂To~ʎM.setGuardCondition(~);
		transition~ʑ҂To~ʎM.addAction(~ʂ󂯎);
		transition~ʎMToTerminalState.setGuardCondition(~ꂽꍇ);
		transition~ʎMToTerminalState.addAction(purchaseBehaviorN);

		//connection of transitions
		transition~ʎMTo~Fԑ҂.setSourceState(~ʎM);
		transition~ʎMTo~Fԑ҂.setTargetState(~Fԑ҂);
		transition~Fԑ҂To~ʑ҂.setSourceState(~Fԑ҂);
		transition~Fԑ҂To~ʑ҂.setTargetState(~ʑ҂);
		transition~ʑ҂To~ʎM.setSourceState(~ʑ҂);
		transition~ʑ҂To~ʎM.setTargetState(~ʎM);
		transition~ʎMToTerminalState.setSourceState(~ʎM);
		transition~ʎMToTerminalState.setTargetState(terminalState);
		transitionInitialStateTo~Fԑ҂.setSourceState(initialState);
		transitionInitialStateTo~Fԑ҂.setTargetState(~Fԑ҂);

	}

	/**
	*~ʂ󂯎
	*/
	protected abstract void ~ʂ󂯎();
	/**
	*~˗
	*/
	protected abstract void ~˗();
	/**
	*purchaseBehaviorN
	*/
	protected abstract void purchaseBehaviorN();
	/**
	*~ꂽꍇ
	*/
	protected abstract boolean ~ꂽꍇ(Event e);
	/**
	*~
	*/
	protected abstract boolean ~(Event e);
	/**
	*vCRĂȂꍇ
	*/
	protected abstract boolean vCRĂȂꍇ(Event e);
	/**
	*~Ȃꍇ
	*/
	protected abstract boolean ~Ȃꍇ(Event e);
}
