package org.boxed_economy.formatcompetition.model.behavior;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

/**
* AbstractSurveyBehavior
*/
public abstract class AbstractSurveyBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from AbstractBehavior Builder
	* Don't touch by hand
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState Jnԑ҂ = factory.createCompositeState("Jnԑ҂");
		CompositeState ԓ҂ = factory.createCompositeState("ԓ҂");

		//actions
		Action sVFAvZ = new Action() {
			public void doAction() {
				sVFAvZ();
			}
			public String toString() {
				return "sVFAvZ";
			}
		};
		Action S҂ɎgpKiq˂ = new Action() {
			public void doAction() {
				S҂ɎgpKiq˂();
			}
			public String toString() {
				return "S҂ɎgpKiq˂";
			}
		};
		Action sVFAԓ = new Action() {
			public void doAction() {
				sVFAԓ();
			}
			public String toString() {
				return "sVFAԓ";
			}
		};
		Action KiL = new Action() {
			public void doAction() {
				KiL();
			}
			public String toString() {
				return "KiL";
			}
		};

		//guard-conditions
		GuardCondition sVFA˗ = new GuardCondition() {
			public boolean isMatched(Event e) {
				return sVFA˗(e);
			}
		};
		GuardCondition ׂĂ̕ԓ󂯎ꍇ = new GuardCondition() {
			public boolean isMatched(Event e) {
				return ׂĂ̕ԓ󂯎ꍇ(e);
			}
		};
		GuardCondition Ki = new GuardCondition() {
			public boolean isMatched(Event e) {
				return Ki(e);
			}
		};

		//transitions
		Transition transitionԓ҂ToJnԑ҂ = factory.createTransition();
		Transition transitionInitialStateToJnԑ҂ = factory.createTransition();
		Transition transitionԓ҂Toԓ҂ = factory.createTransition();
		Transition transitionJnԑ҂ToJnԑ҂ = factory.createTransition();
		Transition transitionJnԑ҂Toԓ҂ = factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(Jnԑ҂);
		this.addState(ԓ҂);

		//transitions setting
		transitionԓ҂ToJnԑ҂.setGuardCondition(ׂĂ̕ԓ󂯎ꍇ);
		transitionԓ҂ToJnԑ҂.addAction(sVFAvZ);
		transitionԓ҂Toԓ҂.setEvent(ChannelEvent.class);
		transitionԓ҂Toԓ҂.setGuardCondition(Ki);
		transitionԓ҂Toԓ҂.addAction(KiL);
		transitionJnԑ҂ToJnԑ҂.setEvent(ChannelEvent.class);
		transitionJnԑ҂ToJnԑ҂.setGuardCondition(sVFA˗);
		transitionJnԑ҂ToJnԑ҂.addAction(sVFAԓ);
		transitionJnԑ҂Toԓ҂.setEvent(TimeEvent.class);
		transitionJnԑ҂Toԓ҂.addAction(S҂ɎgpKiq˂);

		//connection of transitions
		transitionԓ҂ToJnԑ҂.setSourceState(ԓ҂);
		transitionԓ҂ToJnԑ҂.setTargetState(Jnԑ҂);
		transitionInitialStateToJnԑ҂.setSourceState(initialState);
		transitionInitialStateToJnԑ҂.setTargetState(Jnԑ҂);
		transitionԓ҂Toԓ҂.setSourceState(ԓ҂);
		transitionԓ҂Toԓ҂.setTargetState(ԓ҂);
		transitionJnԑ҂ToJnԑ҂.setSourceState(Jnԑ҂);
		transitionJnԑ҂ToJnԑ҂.setTargetState(Jnԑ҂);
		transitionJnԑ҂Toԓ҂.setSourceState(Jnԑ҂);
		transitionJnԑ҂Toԓ҂.setTargetState(ԓ҂);

	}

	/**
	*sVFAvZ
	*/
	protected abstract void sVFAvZ();
	/**
	*S҂ɎgpKiq˂
	*/
	protected abstract void S҂ɎgpKiq˂();
	/**
	*sVFAԓ
	*/
	protected abstract void sVFAԓ();
	/**
	*KiL
	*/
	protected abstract void KiL();
	/**
	*sVFA˗
	*/
	protected abstract boolean sVFA˗(Event e);
	/**
	*ׂĂ̕ԓ󂯎ꍇ
	*/
	protected abstract boolean ׂĂ̕ԓ󂯎ꍇ(Event e);
	/**
	*Ki
	*/
	protected abstract boolean Ki(Event e);
}
