/*
 * LogitSelectionModel.java
 * Copyright (c) 2002 Boxed-Economy Project.  All rights reserved.
 */
package org.boxed_economy.formatcompetition.model.function;

import org.boxed_economy.besp.model.fmfw.Type;

/**
 * @author macchan
 * @version $Id: LogitSelectionModel.java,v 1.1 2004/06/10 08:10:22 bam Exp $
 */
public class LogitSelectionModel {

	private Type candidate = null;
	private double u = 0.0;

	/**
	 * Constructor for LogitSelectionModel.
	 */
	public LogitSelectionModel(Type candidate, double u) {
		this.candidate = candidate;
		this.u = u;
	}

	/**
	 * Returns the candidate.
	 * @return Type
	 */
	public Type getCandidate() {
		return candidate;
	}

	/**
	 * Returns the u.
	 * @return double
	 */
	public double getU() {
		return u;
	}

}
